#!/usr/bin/python

import sys
import subprocess
import gobject
import pygtk
pygtk.require('2.0')
import gtk
import os
from os.path import join, getsize
import dbus
from dbus.mainloop.glib import DBusGMainLoop
import gnomevfs
import gettext
import shutil
import filecmp
import re
import thread
import threading
import time
import formateador_backend

PATH="/usr/share/formateadorusb"

class formateador_Frontend:
	def __init__(self):
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_position(gtk.WIN_POS_CENTER)
                self.window.set_border_width(10)
		self.window.set_size_request(400, 400)
                self.window.set_title(_('Formateador USB'))
		self.window.set_icon_from_file('%s/img/formateadorusb.png' % PATH)

		self.box = gtk.VBox(False, 10)
                self.window.add(self.box)

		self.window.connect("delete_event", self.delete_event)
                self.window.connect("destroy", self.destroy)

		# Lista de dispositivos
		# - Etiqueta de la lista
		self.et_lista = gtk.Label()
                self.et_lista.set_markup(_('<b>Dispositivos Conectados</b>'))
                self.et_lista.set_use_markup(True)
		self.box.pack_start(self.et_lista, False, True, 0)
		# - Lista
		self.contenedor_lista = gtk.ScrolledWindow()
                self.contenedor_lista.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
                self.contenedor_lista.set_shadow_type(gtk.SHADOW_IN)
                self.listado = gtk.ListStore(str, str, str, str, str)
                self.vista_arbol_lista = gtk.TreeView()
                self.vista_arbol_lista.set_model(self.listado)
		self.contenido_columna_1 = gtk.CellRendererText()
                self.columna_1 = gtk.TreeViewColumn(_('Dispositivo'), self.contenido_columna_1, text=0)
                self.vista_arbol_lista.append_column(self.columna_1)
		self.contenido_columna_2 = gtk.CellRendererText()
                self.columna_2 = gtk.TreeViewColumn(_('Dev'), self.contenido_columna_2, text=1)
		self.columna_2.set_visible(False)
                self.vista_arbol_lista.append_column(self.columna_2)
		self.contenido_columna_3 = gtk.CellRendererText()
                self.columna_3 = gtk.TreeViewColumn(_('Capacidad'), self.contenido_columna_3, text=2)
                self.vista_arbol_lista.append_column(self.columna_3)
		self.contenido_columna_4 = gtk.CellRendererText()
                self.columna_4 = gtk.TreeViewColumn(_('Etiqueta'), self.contenido_columna_4, text=3)
                self.vista_arbol_lista.append_column(self.columna_4)
		self.contenido_columna_5 = gtk.CellRendererText()
                self.columna_5 = gtk.TreeViewColumn(_('Devroot'), self.contenido_columna_5, text=4)
                self.vista_arbol_lista.append_column(self.columna_5)
		self.columna_5.set_visible(False)
		self.seleccion_vista = self.vista_arbol_lista.get_selection()
                self.seleccion_vista.set_mode(gtk.SELECTION_SINGLE)
		self.seleccion_vista.connect("changed", self.actualizar_info_dispositivo)
		self.contenedor_lista.add(self.vista_arbol_lista)
                self.contenedor_lista.show_all()
		self.box.pack_start(self.contenedor_lista, True, True, 0)
		# Fin lista de dispositivos

		## -Cuadro de texto para etiqueta
		self.hbox_etiqueta = gtk.HBox(False, 5)
		self.et_etiquetado = gtk.Label('Etiqueta (opcional): ')
		self.entry_etiquetado = gtk.Entry()
		self.hbox_etiqueta.pack_start(self.et_etiquetado, False, False, 0)
		self.hbox_etiqueta.pack_start(self.entry_etiquetado, True, True, 0)
		self.et_etiquetado.show()
		self.entry_etiquetado.show()
		self.hbox_etiqueta.show()
		self.box.pack_start(self.hbox_etiqueta, False, False, 0)
		## Fin de cuadro de texto para etiqueta
	
		## -Boton de formatear
		self.hbox_boton_for = gtk.HBox(False,5)
		self.b_iniciar_for = gtk.Button('Formatear llavero USB seleccionado')
		self.b_iniciar_for.set_tooltip_text(_('Formatear llavero USB seleccionado'))
		self.imagen_for = gtk.Image()
		self.imagen_for.set_from_file('%s/img/formatea.png' % PATH)
		self.b_iniciar_for.set_image(self.imagen_for)
		self.b_iniciar_for.connect("clicked", self.comienza_formato)
		self.b_iniciar_for.set_sensitive(False)
		self.hbox_boton_for.pack_start(self.b_iniciar_for, True, False, 0)
		self.b_iniciar_for.show()
		self.hbox_boton_for.show()
		self.box.pack_start(self.hbox_boton_for, False, False, 0)
		## Fin de boton formatear

		self.backend = formateador_backend.formateador_Backend(self)
		self.backend.detectar_dispositivos()

		self.et_lista.show()
		self.box.show()	
		self.window.show()

	def actualizar_listado(self, disp):
		texto = None
		if disp['udi']:
			drive = self.get_gnome_drive(disp['udi'])
			if drive:
				texto = drive.get_display_name()
			else:
				texto = disp['mountpoint']
		else:
			texto = disp['filename']
		aux = self.vista_arbol_lista.get_model()
		iter = aux.get_iter_first()
		while iter is not None:
			if aux.get_value(iter, 1) == disp['device']:
				aux.set_value(iter, 0, texto)
				aux.set_value(iter, 1, disp['device'])
				aux.set_value(iter, 2, formateador_backend.format_size(disp['capacity']))
				aux.set_value(iter, 3, disp['label'])
				aux.set_value(iter, 4, disp['devroot'])
			iter = aux.iter_next(iter)

	def incluir_dispositivo(self, disp):
		texto = None
		if disp['udi']:
			drive = self.get_gnome_drive(disp['udi'])
			if drive:
				texto = drive.get_display_name()
			else:
				texto = disp['mountpoint']
		else:
			texto = disp['filename']
		self.listado.append([texto, disp['device'], formateador_backend.format_size(disp['capacity']), disp['label'], disp['devroot']])

	def borrar_dispositivo(self, disp):
		borrar = None
		aux = self.vista_arbol_lista.get_model()
		iter = aux.get_iter_first()
		while iter is not None:
			if aux.get_value(iter, 1) == disp:
				borrar = iter
			iter = aux.iter_next(iter)
		if borrar  is not None:
			aux.remove(borrar)
	
	def actualizar_info_dispositivo(self, widget, data = None):
		device = None
		(aux, iter) = self.seleccion_vista.get_selected()
		if iter is not None:
			device = aux.get_value(iter, 1)
		else:
			self.b_iniciar_for.set_sensitive(False)
			
		if device is not None:
			disp = self.backend.devices[device]
			self.b_iniciar_for.set_sensitive(True)
			self.dispositivo_seleccionado = disp

	def comienza_formato(self, widget, data = None):
		device = self.dispositivo_seleccionado['devroot']
		self.backend.formatear_dispositivo(device)
		#self.borrar_dispositivo(self.dispositivo_seleccionado['device'])

	def get_gnome_drive(self, udi):
		monitor = gnomevfs.VolumeMonitor()
		for drive in monitor.get_connected_drives():
			if drive.get_hal_udi() == udi:
				return drive

	def delete_event(self, widget, data = None):
		gtk.main_quit()

	def destroy(self, widget, data = None):
		gtk.main_quit()

def main():
	gtk.gdk.threads_init()
        gtk.main()

if __name__ =="__main__":
	front = formateador_Frontend()
	main()
